#!/bin/ksh

### check export tool ###

# input variables #

name=$1
passwd=$2
ip=$3
serial_number=$4
id=$5
firmware=$6


if [ ! -d $VSP_CLIDIR/hds_test ]; then
  mkdir $VSP_CLIDIR/hds_test
  mkdir $VSP_CLIDIR/hds_test/performance
fi

dir="$VSP_CLIDIR/hds_test"
command_file="$VSP_CLIDIR/hds_test/command.txt"
command_file2="$VSP_CLIDIR/hds_test/command2.txt"
perf="$VSP_CLIDIR/hds_test/performance"

if [ ! x"$HDS_EXPORT_TOOL_JAVAPATH" = "x" ]; then
  export PATH=$HDS_EXPORT_TOOL_JAVAPATH:$PATH
fi

type_storage_file=`raidcom get resource -key opt $id 2>/dev/null | grep "meta_resource"`
if [ ! $? -eq 0 ]; then
  echo "VSPG Error: command failed: raidcom get resource -key opt $id"
  exit 1
fi

type_storage=`echo $type_storage_file | awk '{print $4}'`

#if [ "$type_storage" = "M8M" -o "$type_storage" = "M8S" -o "$type_storage" = "M8H" ]; then

    echo "ip $ip        ; Specifies IP adress of SVP" > $command_file
    echo "dkcsn $serial_number           ; Specifies Serial Number of SVP" >> $command_file
    echo "login \"$name\" \"$passwd\"   ; Logs user into DKC" >> $command_file
    echo "show                  ; output storing period" >> $command_file
    echo "group Port ; Port usage" >> $command_file
    echo "range -0001:" >> $command_file
    echo "outpath \"$perf\"  ; specifies the sub-directory in which files will be saved" >> $command_file
    echo "option nocompress" >> $command_file
    echo "apply" >> $command_file
#else
    echo "svpip $ip        ; Specifies IP adress of SVP" > $command_file2
    echo "login \"$name\" \"$passwd\"   ; Logs user into DKC" >> $command_file2
    echo "show                  ; output storing period" >> $command_file2
    echo "group Port ; Port usage" >> $command_file2
    echo "shortrange -0001:" >> $command_file2
    echo "outpath \"$perf\"  ; specifies the sub-directory in which files will be saved" >> $command_file2
    echo "option nocompress" >> $command_file2
    echo "apply" >> $command_file2
#fi

### runUnix.bat ###

perf_file="$VSP_CLIDIR/$firmware/runUnix.bat"
if [ ! -f $perf_file ]; then
  echo "VSPG Error: File $perf_file does not exist !!!"
  echo "Check install export tool"
  exit 1
fi

lib="$VSP_CLIDIR/$firmware"
conversion=`echo $lib | sed 's/\//abc:/g'`
input=`echo $VSP_CLIDIR | sed 's/\//abc:/g'`

command=`cat $perf_file | grep "java" | sed 's/command=/command='$input'\/hds_test\//g' | sed 's/\.\/lib/'$conversion'\/lib/g' | sed 's/=log/='$conversion'\/log/g'`
command=`echo $command | sed 's/abc:/\//g' | sed 's/"//g'`
command2=`cat $perf_file | grep "java" | sed 's/command=/command='$input'\/hds_test\//g' | sed 's/command\.txt/command2\.txt/g' | sed 's/\.\/lib/'$conversion'\/lib/g' | sed 's/=log/='$conversion'\/log/g'`
command2=`echo $command2 | sed 's/abc:/\//g' | sed 's/"//g'`
#rm -r $perf/* 2>/dev/null
i=0

if [ "$type_storage" = "M8M" -o "$type_storage" = "M8S" -o "$type_storage" = "M8H" ]; then
  i=1
  $command
elif [ "$type_storage" = "R8" -o "$type_storage" = "M7" -o "$type_storage" = "R7" -o "$type_storage" = "R6" -o "$type_storage" = "RK6" -o "$type_storage" = "R5" -o "$type_storage" = "RK5" ]; then
  i=2
  $command2
else
  i=2
  $command2
fi
if [ ! $? -eq 0 ]; then
  path="$VSP_CLIDIR/$firmware/log"
  file=`ls -t $path | head -1`
  content=`cat "$path/$file"`
  echo "$content"
  if [ $i -eq 1 ]; then
    $command2
  else
    $command
  fi
  if [ ! $? -eq 0 ]; then
    path="$VSP_CLIDIR/$firmware/log"
    file=`ls -t $path | head -1`
    content=`cat "$path/$file"`
    echo "$content"
    echo "VSPG Error: export tool finished mistake"
    echo "set up or check HDS_EXPORT_TOOL_JAVAPATH in stor2rrd.cfg"
    #rm -r $VSP_CLIDIR/hds_test/* 2>/dev/null
    #rmdir $VSP_CLIDIR/hds_test 2>/dev/null
    exit 1
  fi
fi
rm -r $VSP_CLIDIR/hds_test/* 2>/dev/null
rmdir $VSP_CLIDIR/hds_test 2>/dev/null
