#!/usr/bin/perl

use strict;
use warnings;
use Data::Dumper;
no warnings 'portable';


my $STORAGE_NAME        = $ENV{STORAGE_NAME};
my $BASEDIR             = $ENV{INPUTDIR};
my $bindir              = $ENV{BINDIR};
my $webdir              = $ENV{WEBDIR};
my $inputdir            = $ENV{INPUTDIR};
my $wrkdir              = "$BASEDIR/data/$STORAGE_NAME";
my $configuration       = "$wrkdir/IOSTATS";
my $config_directory    = "";
my $command_file        = "$wrkdir/$STORAGE_NAME-commnad.txt";
my $ip_adress           = $ENV{VSPG_IP};
my $login               = $ENV{VSPG_USER};
my $paswd               = $ENV{VSPG_PW};
my $cli_dir             = $ENV{VSP_CLIDIR};
my $id_storage          = $ENV{VSPG_CONF_ID};
my $autetization        = "-I$id_storage";
my $host_creation_force = $ENV{HOST_CREATION_FORCE};

## encode paswd ##
my $pom_paswd = unobscure_password($paswd);
$paswd = $pom_paswd;

my $output_file;
my $file_tmp = get_name_conf_file();
my @volumes;
my @mapping;
my $timeout_cmd_high   = 360;
my $timeout_cmd_normal = 180;
my $timeout_cmd_low    = 60;
my $error              = 0;

### MAIN FUNCTION ###

data_structure();
my $act_directory = localtime();

#my @entry_time = split(" ",$act_directory);
#(undef, my $active_minute, undef) =  split(":",$entry_time[3]);
my $active_minute = "configuration";
$config_directory = "$configuration/$active_minute";

### verify run vspgconf.pl ###

run_vspgconf();

###

#set_configuration_header();

my $cmd  = "raidcom -login $login $paswd $autetization";
my $file = "/dev/null";

# try login and logout per section

cmd( $cmd, $file, $timeout_cmd_low );
set_configuration_header();
set_data_ldev();
$cmd = "raidcom -logout $autetization";
cmd( $cmd, $file, $timeout_cmd_low );

$cmd = "raidcom -login $login $paswd $autetization";
cmd( $cmd, $file, $timeout_cmd_low );
set_data_pool();
$cmd = "raidcom -logout $autetization";
cmd( $cmd, $file, $timeout_cmd_low );

$cmd = "raidcom -login $login $paswd $autetization";
cmd( $cmd, $file, $timeout_cmd_low );
set_data_port();
$cmd = "raidcom -logout $autetization";
cmd( $cmd, $file, $timeout_cmd_low );

$cmd = "raidcom -login $login $paswd $autetization";
cmd( $cmd, $file, $timeout_cmd_low );
set_data_rg();
$cmd = "raidcom -logout $autetization";
cmd( $cmd, $file, $timeout_cmd_low );

# Host section login and logout per command
set_data_host();

#set_data_volume();

set_data_mapping();

if ( $error == 0 ) {
  `touch "$config_directory/config-$STORAGE_NAME.touch"`;
}
rename( "$file_tmp", "$output_file" );

###

sub unobscure_password {
  my $string    = shift;
  my $unobscure = DecodeBase64($string);
  $unobscure = unpack( chr( ord("a") + 19 + print "" ), $unobscure );
  return $unobscure;
} ## end sub unobscure_password

sub DecodeBase64 {
  my $d = shift;
  $d =~ tr!A-Za-z0-9+/!!cd;
  $d =~ s/=+$//;
  $d =~ tr!A-Za-z0-9+/! -_!;
  my $r = '';
  while ( $d =~ /(.{1,60})/gs ) {
    my $len = chr( 32 + length($1) * 3 / 4 );
    $r .= unpack( "u", $len . $1 );
  }
  $r;
} ## end sub DecodeBase64

sub run_vspgconf {
  my $file = "$config_directory/config-$STORAGE_NAME.touch";
  my $test_file = test_file_exist( $file, "run" );
  if ($test_file) {
    my $mtime       = ( stat("$file") )[9];
    my $last_update = time() - $mtime;
    if ( $last_update >= 3600 ) {
      return;
    }
    else {
      exit(1);
    }
  } ## end if ($test_file)
  else {
    return;
  }

} ## end sub run_vspgconf

sub correct_raidcom_command {
  my $file       = shift;
  my $file2      = shift;
  my $test_exist = test_file_exist($file);
  if ( $test_exist == 0 ) {
    return $test_exist;
  }
  if ( ( defined $file2 && !test_file_exist($file2) ) || ( defined $file2 && find_host() ) ) {
    return 0;
  }
  my @array = get_array_data($file);
  my $test = grep {/User for/} @array;
  return $test;

} ## end sub correct_raidcom_command

sub test_host_file {
  my $file     = shift;
  my $file_tmp = shift;

  if ( test_file_exist($file) ) {
    my @array         = get_array_data($file);
    my @array_tmp     = get_array_data($file_tmp);
    my $file_size     = ( stat($file) )[7];
    my $file_tmp_size = ( stat($file_tmp) )[7];
    my $file_time     = ( stat($file) )[9];
    my $act_time      = time();
    my $test          = grep {/User for/} @array;
    if ( $test > 0 ) {

      if ( ( $file_time + ( 24 * 3600 ) < $act_time ) && $file_tmp_size > $file_size ) {
        return 1;
      }
    } ## end if ( $test > 0 )
    my $test_tmp = grep {/User for/} @array_tmp;
    if ( $test_tmp == 0 ) {
      return 1;
    }
  } ## end if ( test_file_exist($file...))
  return 0;
} ## end sub test_host_file

sub find_host {
  my $dir        = "$wrkdir/HOST";
  my @host_files = <$dir/*>;
  my $active     = 1;

  foreach my $file (@host_files) {
    if ( ( $file =~ m/rrd$/ || $file =~ m/hosts.cfg$/ ) && test_file_exist($file) ) {
      $active = 0;
      last;
    }
  } ## end foreach my $file (@host_files)
  return $active;

} ## end sub find_host

sub check_space_name {
  my $name       = shift;
  my $name_space = $name;
  if ( $name =~ m/ / ) {
    $name_space = "\"" . $name . "\"";    # it must be here to support space with server names
    return $name_space;
  }
  else {
    return $name;
  }
} ## end sub check_space_name

sub data_structure {
  my $directory = $configuration;
  if ( !-d $directory ) {
    mkdir $directory || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
  }
  if ( !-d "$directory/configuration" ) {
    mkdir "$directory/configuration" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
  }

  for ( my $i = 0; $i < 60; $i = $i + 5 ) {
    if ( $i < 10 ) {
      if ( !-d "$directory/0$i" ) {
        mkdir "$directory/0$i" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
      }
    }
    else {
      if ( !-d "$directory/$i" ) {
        mkdir "$directory/$i" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
      }
    }
  } ## end for ( my $i = 0; $i < 60...)
} ## end sub data_structure

sub get_name_conf_file {
  my $dir        = "$wrkdir";      ### for testing
  my @time       = localtime();
  my $time_human = localtime();
  my $sec        = $time[0];
  my $minute     = $time[1];
  my $hour       = $time[2];
  my $day        = $time[3];
  my $month      = $time[4] + 1;
  my ( undef, undef, undef, undef, $year ) = split( " ", $time_human );
  chomp $year;

  if ( $minute < 10 ) { $minute = "0$minute"; }
  if ( $hour < 10 )   { $hour   = "0$hour"; }
  if ( $day < 10 )    { $day    = "0$day"; }
  if ( $month < 10 )  { $month  = "0$month"; }
  my $name_file = "$dir/$STORAGE_NAME" . "_" . "vspgconf" . "_" . "$year$month$day" . "_" . "$hour$minute" . ".out-tmp";
  $output_file = "$dir/$STORAGE_NAME" . "_" . "vspgconf" . "_" . "$year$month$day" . "_" . "$hour$minute" . ".out";

  #print "$name_file\n";
  return $name_file;

} ## end sub get_name_conf_file

sub get_separator {
  my $header = shift;
  my $count  = length($header);
  my $separator;
  for ( my $i = 0; $i < $count; $i++ ) {
    $separator = $separator . "-";
  }
  return "$separator";
} ## end sub get_separator

sub set_data_port {
  my $file_port = create_port_file();
  my $section   = "Port Level Configuration";
  my $header    = ",,name,,,,,,";
  my $metric    = "PORT,TYPE,ATTR";

  my @data = get_data_port( $file_port, $section, $metric );
  set_write_data( $section, $header, \@data );

} ## end sub set_data_port

sub create_port_file {
  my $file_tmp = "$config_directory/config-PORT.txt-tmp";
  my $file     = "$config_directory/config-PORT.txt";

  my $test = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }

  my $cmd = "raidcom get port $autetization";
  cmd( $cmd, $file_tmp, $timeout_cmd_normal );
  $test = test_file_exist($file_tmp);
  if ($test) {
    my $test2 = correct_raidcom_command($file_tmp);
    if ( $test2 == 0 ) {
      rename( "$file_tmp", "$file" );
    }
  } ## end if ($test)
  else {
    $error++;
  }

  return $file;
} ## end sub create_port_file

sub create_volume_file {
  my $file     = "$config_directory/config-VOLUME.txt";
  my $file_tmp = "$config_directory/config-VOLUME.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }
  my $file_in = "$config_directory/config-PORT.txt";
  my @array   = get_array_data($file_in);
  foreach my $line (@array) {
    chomp $line;
    if ( $line eq "" ) { next; }
    $line = remove_whitespace($line);
    if ( $line =~ /TAR/ ) {
      my @elements = split( " ", $line );
      $elements[0] = remove_whitespace( $elements[0] );
      my $cmd      = "raidvchkscan -v aou -p $elements[0] $autetization";
      my $save_end = "save";
      cmd( $cmd, $file_tmp, $timeout_cmd_normal, $save_end );
      my $test2 = correct_raidcom_command($file_tmp);
      if ( $test2 != 0 ) {
        return $file;
      }
    } ## end if ( $line =~ /TAR/ )
  } ## end foreach my $line (@array)
  $test = test_file_exist($file_tmp);
  if ($test) {
    rename( "$file_tmp", "$file" );
  }
  else {
    $error++;
  }

  return $file;
} ## end sub create_volume_file

sub set_data_rg {

  ### verify raid group rrd files ###

  my $space_config_directory = check_space_name($wrkdir);
  my @files                  = <$space_config_directory/RANK/*>;
  my $size_array             = scalar @files;
  if ( $size_array == 0 ) { return 0; }

  ###

  my $file_rg  = create_parity_gr_file();
  my $file_rg2 = create_parity_gr_file2();
  my $section  = "Raid Group Level Configuration";
  my $metric   = "T,GROUP,Num_LDEV,U(%),AV_CAP(GB),R_LVL,R_TYPE,SL,CL,DRIVE_TYPE";
  my $header   = ",id,status,,,capacity (GB),,free_capacity (GB),,used_capacity (GB),,,,,,,,";
  my @data     = get_data_rg( $file_rg, $file_rg2, $section, $metric );
  set_write_data( $section, $header, \@data );

} ## end sub set_data_rg

sub create_parity_gr_file {
  my $file     = "$config_directory/config-RG.txt";
  my $file_tmp = "$config_directory/config-RG.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }
  my $cmd = "raidcom get parity_grp $autetization";
  cmd( $cmd, $file_tmp, $timeout_cmd_normal );
  $test = test_file_exist($file_tmp);
  if ($test) {
    my $test2 = correct_raidcom_command($file_tmp);
    if ( $test2 == 0 ) {
      rename( "$file_tmp", "$file" );
    }
  } ## end if ($test)
  else {
    $error++;
  }
  return $file;
} ## end sub create_parity_gr_file

sub create_parity_gr_file2 {
  my $file     = "$config_directory/config-RG2.txt";
  my $file_tmp = "$config_directory/config-RG2.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }
  my $file_in = "$config_directory/config-RG.txt";
  my @array   = get_array_data($file_in);

  foreach my $line (@array) {
    chomp $line;
    if ( $line eq "" ) { next; }
    $line = remove_whitespace($line);
    if ( !( index( $line, "GROUP" ) > -1 ) ) {
      my @element = split( " ", $line );
      $element[1] = remove_whitespace( $element[1] );
      my $cmd      = "raidcom get parity_grp -parity_grp_id $element[1] $autetization";
      my $save_end = "save";
      cmd( $cmd, $file_tmp, $timeout_cmd_normal, $save_end );
      my $test2 = correct_raidcom_command($file_tmp);
      if ( $test2 != 0 ) {
        return $file;
      }
    } ## end if ( !( index( $line, ...)))
  } ## end foreach my $line (@array)
  $test = test_file_exist($file_tmp);
  if ($test) {
    rename( "$file_tmp", "$file" );
  }
  else {
    $error++;
  }
  return $file;
} ## end sub create_parity_gr_file2

sub get_data_volume {
  my ( $file, $metric, $section ) = @_;
  my @data = get_array_data($file);
  my %header;
  my $key_header = "LU#";
  my @metrics = split( ",", $metric );
  my @lu;

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }
    if ( $line =~ /$key_header/ ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;

        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
    } ## end if ( $line =~ /$key_header/)
    else {
      if ( $line =~ /User for/ ) { next; }
      my $lun       = "";
      my $cap_total = "";
      my $cap_used  = "";
      my $cap_free  = "";
      if ( defined $header{$section} ) {
        foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
          if ( defined $header{$section}{$id}{LENGTH} ) {
            my $name = $header{$section}{$id}{NAME};
            if ( $name ne "LU#" && $name ne "Used(MB)" && $name ne "LU_CAP(MB)" ) { next; }
            my $start  = $header{$section}{$id}{START};
            my $length = $header{$section}{$id}{LENGTH};
            if ( $start == 0 ) { $length--; }
            my $value = substr( $line, $start, $length );
            $value = remove_whitespace($value);

            if ( $name eq "LU#" ) {
              $lun = $value;
            }
            if ( $name eq "Used(MB)" ) {
              $cap_used = $value;
            }
            if ( $name eq "LU_CAP(MB)" ) {
              $cap_total = $value;
            }

            if ( $lun ne "" && $cap_total ne "" && $cap_used ne "" ) {
              $cap_free = $cap_total - $cap_used;
              my $active = 0;
              foreach my $row (@lu) {
                my @element = split( ",", $row );
                if ( "$element[0]" eq "$lun" ) {
                  $active = 1;
                }
              } ## end foreach my $row (@lu)
              if ( $active == 0 ) {
                push( @lu, "$lun,,,,,,,,$cap_total,,,,,,,,,,,,,\n" );
              }
            } ## end if ( $lun ne "" && $cap_total...)
          } ## end if ( defined $header{$section...})
        } ## end foreach my $id ( sort { $a ...})
      } ## end if ( defined $header{$section...})
    } ## end else [ if ( $line =~ /$key_header/)]
  } ## end foreach my $line (@data)
  return @lu;
} ## end sub get_data_volume

sub set_data_volume {
  my $file    = create_volume_file();
  my $section = "Lun Level Configuration";
  my $header  = "lun_id,,,,,,pool_id,,capacity (MB),,,,,,,,,,,,interface_type,raid_group_id";
  my $metric  = "PORT#,/ALPA/C,TID#,LU#,Seq#,Num,LDEV#,Used(MB),LU_CAP(MB),U(%),T(%),PID";
  my @lun     = get_data_volume( $file, $metric, $section );
  set_write_data( $section, $header, \@lun );

} ## end sub set_data_volume

sub set_data_pool {
  my $file1   = create_pool1_file();
  my $file2   = create_pool2_file();
  my $section = "Pool Level Configuration";
  my $header  = "name,id,status,,,capacity (GB),,free_capacity (GB),,used_capacity (GB),,,,,,,,";
  my $metric1 = "PID,POLS,U(%),POOL_NAME,Seq#,Num,LDEV#,H(%),VCAP(%),TYPE,PM,PT";
  my $metric2 = "PID,POLS,U(%),SSCNT,Available(MB),Capacity(MB),Seq#,Num,LDEV#,H(%)";

  #my $metric2 = "PID,POLS,U(%),AV_CAP(MB),TP_CAP(MB),W(%),H(%),Num,LDEV#,LCNT,TL_CAP(MB),BM,TR_CAP(MB),RCNT";
  my @pool = get_data_pool( $file1, $file2, $metric1, $metric2, $section );
  set_write_data( $section, $header, \@pool );
} ## end sub set_data_pool

sub get_data_pool {
  my $file1      = shift;
  my $file2      = shift;
  my $metric     = shift;
  my $metric2    = shift;
  my $section    = shift;
  my @metrics    = split( ",", $metric );
  my $key_header = "PID";
  my %header;
  my @data_pool;
  my %pool;

  my @data = get_array_data($file1);

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }
    if ( $line =~ /$key_header/ ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;
        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
      foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
        if ( !defined $header{$section}{$id}{LENGTH} && defined $header{$section}{$id}{START} ) {
          $header{$section}{$id}{LENGTH} = "LAST";
          last;
        }
      } ## end foreach my $id ( sort { $a ...})

    } ## end if ( $line =~ /$key_header/)
    else {
      if ( $line =~ /User for/ ) { next; }
      my $pool_id   = "";
      my $pool_name = "";
      if ( defined $header{$section} ) {
        foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
          if ( defined $header{$section}{$id}{LENGTH} ) {
            my $name = $header{$section}{$id}{NAME};
            if ( $name ne "POOL_NAME" && $name ne "PID" ) { next; }
            my $start  = $header{$section}{$id}{START};
            my $length = $header{$section}{$id}{LENGTH};
            if ( $length eq "LAST" ) {
              $length = length($line);
            }
            if ( $start == 0 ) { $length--; }
            my $value = substr( $line, $start, $length );
            $value = remove_whitespace($value);
            if ( $name eq "PID" ) {
              $pool_id = $value;
            }
            if ( $name eq "POOL_NAME" ) {
              $pool_name = $value;
              if ( $pool_name =~ /  / ) {
                $pool_name =~ s/  +.*//g;
                $pool_name = remove_whitespace($pool_name);
              }
            } ## end if ( $name eq "POOL_NAME")
          } ## end if ( defined $header{$section...})
        } ## end foreach my $id ( sort { $a ...})
        if ( $pool_id ne "" ) {
          my $id_len = length($pool_id);
          my @chars = split( "", $pool_id );
          if ( $id_len > 1 ) {
            for ( my $i = 0; $i < $id_len - 1; $i++ ) {
              if ( $chars[$i] eq "0" ) {
                $pool_id =~ s/^.//g;
              }
              else {
                last;
              }
            } ## end for ( my $i = 0; $i < $id_len...)
          } ## end if ( $id_len > 1 )
          if ( !defined $pool{$pool_id} ) {
            $pool{$pool_id} = $pool_name;
          }
        } ## end if ( $pool_id ne "" )
      } ## end if ( defined $header{$section...})
    } ## end else [ if ( $line =~ /$key_header/)]
  } ## end foreach my $line (@data)

  #print Dumper \%pool;
  @metrics = split( ",", $metric2 );
  @data = get_array_data($file2);

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }
    if ( $line =~ /$key_header/ ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;

        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
      foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
        if ( !defined $header{$section}{$id}{LENGTH} && defined $header{$section}{$id}{START} ) {
          $header{$section}{$id}{LENGTH} = "LAST";
          last;
        }
      } ## end foreach my $id ( sort { $a ...})
    } ## end if ( $line =~ /$key_header/)
    else {
      if ( $line =~ /User for/ ) { next; }
      my $id_pool    = "";
      my $size_usage = "";
      my $size_free  = "";
      my $size_total = "";
      if ( defined $header{$section} ) {
        foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
          if ( defined $header{$section}{$id}{LENGTH} ) {
            my $name = $header{$section}{$id}{NAME};
            if ( $name ne "PID" && $name ne "Available(MB)" && $name ne "Capacity(MB)" ) { next; }
            my $start  = $header{$section}{$id}{START};
            my $length = $header{$section}{$id}{LENGTH};
            if ( $start == 0 ) { $length--; }
            if ( $length eq "LAST" ) {
              $length = length($line);
            }
            my $value = substr( $line, $start, $length );
            $value = remove_whitespace($value);
            if ( $name eq "PID" ) {
              $id_pool = $value;
            }
            if ( $name eq "Available(MB)" ) {
              $size_free = $value;
            }

            if ( $name eq "Capacity(MB)" ) {
              $size_total = $value;
              if ( $size_total =~ /  / ) {
                $size_total =~ s/ +.*//g;
                $size_total = remove_whitespace($size_total);
              }
            } ## end if ( $name eq "Capacity(MB)")
          } ## end if ( defined $header{$section...})
        } ## end foreach my $id ( sort { $a ...})
        if ( $size_total ne "" && $size_free ne "" ) {
          $size_usage = $size_total - $size_free;
        }
        if ( $size_usage ne "" && $id_pool ne "" ) {
          $size_total = $size_total / (1024);
          $size_total = round($size_total);
          $size_free  = $size_free / (1024);
          $size_free  = round($size_free);
          $size_usage = $size_usage / (1024);
          $size_usage = round($size_usage);
          my $id_len = length($id_pool);
          my @chars = split( "", $id_pool );

          if ( $id_len > 1 ) {
            for ( my $i = 0; $i < $id_len - 1; $i++ ) {
              if ( $chars[$i] eq "0" ) {
                $id_pool =~ s/^.//g;
              }
              else {
                last;
              }
            } ## end for ( my $i = 0; $i < $id_len...)
          } ## end if ( $id_len > 1 )
          if ( defined $pool{$id_pool} ) {
            push( @data_pool, "$pool{$id_pool},$id_pool,,,,$size_total,,$size_free,,$size_usage,,,,,,,,\n" );
          }
          else {
            push( @data_pool, ",$id_pool,,,,$size_total,,$size_free,,$size_usage,,,,,,,,\n" );
          }
        } ## end if ( $size_usage ne ""...)
      } ## end if ( defined $header{$section...})
    } ## end else [ if ( $line =~ /$key_header/)]
  } ## end foreach my $line (@data)
  if ( -e "$wrkdir/POOL/-1.rrd" ) {
    push( @data_pool, "GAD_unknown,-1,,,,0,,0,,0,,,,,,,,\n" );
  }
  return @data_pool;
} ## end sub get_data_pool

sub set_data_mapping {
  my $section = "Port-Mapping Level Configuration";
  my $header  = "Host,Host Group,Ports,Volumes";
  set_write_data( $section, $header, \@mapping );
}

sub set_data_host {

  ## host section must be defined in .magic
  #if (!(defined $host_creation_force && $host_creation_force == 1)){return 0;}
  #my $cmd = "raidcom -login $login $paswd $autetization";
  #my $file = "/dev/null";
  #cmd($cmd,$file,$timeout_cmd_low);
  my $file_host = create_host1_file();

  #$cmd = "raidcom -logout $autetization";
  #cmd($cmd,$file,$timeout_cmd_low);

  my $section = "Host Level Configuration";
  my $header  = ",,name,,,,,Volume IDs,";

  #my $metric = "PORT,GID,HMD,LUN,NUM,LDEV,CM,Serial#,HMO_BITs";
  my $metric = "PORT,GID,GROUP_NAME,Serial#,HDM,HMO_BITs";
  my %host = get_data_host_cfg1( $file_host, $section, $metric );

  #print Dumper \%host;
  #$cmd = "raidcom -login $login $paswd $autetization";
  #cmd($cmd,$file,$timeout_cmd_low);
  $file_host = create_host2_file();

  #$cmd = "raidcom -logout $autetization";
  #cmd($cmd,$file,$timeout_cmd_low);

  $metric = "PORT,GID,HMD,LUN,NUM,LDEV,CM,Serial#,HMO_BITs";
  my %host2 = get_data_host_cfg2( $file_host, $section, $metric, \%host );

  #print Dumper \%host2;
  #$cmd = "raidcom -login $login $paswd $autetization";
  #cmd($cmd,$file,$timeout_cmd_low);
  $file_host = create_host3_file();

  #$cmd = "raidcom -logout $autetization";
  #cmd($cmd,$file,$timeout_cmd_low);

  $metric = "PORT,GID,GROUP_NAME,HWWN,Serial#,NICK_NAME";

  #print Dumper \%host2;
  my %host3 = get_data_host_cfg3( $file_host, $section, $metric, \%host2 );

  #print Dumper \%host3;
  my @data = get_data_host_cfg4( \%host3, $section );

  #print Dumper \@data;
  set_write_data( $section, $header, \@data );

} ## end sub set_data_host

sub create_host1_file {
  my $file     = "$config_directory/config-HOST1.txt";
  my $file_tmp = "$config_directory/config-HOST1.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  my $iterace  = 1;
  if ($test) {
    delete_file($file_tmp);
  }
  my $file_in = "$config_directory/config-PORT.txt";
  my @array   = get_array_data($file_in);
  foreach my $line (@array) {
    chomp $line;
    if ( $line eq "" ) { next; }
    $line = remove_whitespace($line);
    if ( $line =~ /TAR/ ) {
      my @elements = split( " ", $line );
      $elements[0] = remove_whitespace( $elements[0] );
      my $cmd      = "raidcom get host_grp -port $elements[0] $autetization";
      my $save_end = "save";
      if ( $iterace == 1 ) {
        my $file = "/dev/null";
        my $cmd  = "raidcom -login $login $paswd $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
      }
      $iterace++;
      if ( $iterace == 8 ) {
        my $file = "/dev/null";
        my $cmd  = "raidcom -logout $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
        $cmd = "raidcom -login $login $paswd $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
        $iterace = 2;
      } ## end if ( $iterace == 8 )
      cmd( $cmd, $file_tmp, $timeout_cmd_normal, $save_end );

      #my $test2 = correct_raidcom_command($file_tmp,$file);
      #if ($test2 != 0){
      # return $file;
      #}
    } ## end if ( $line =~ /TAR/ )
  } ## end foreach my $line (@array)
  my $file_null = "/dev/null";
  my $cmd_out   = "raidcom -logout $autetization";
  cmd( $cmd_out, $file_null, $timeout_cmd_low );
  $test = test_file_exist($file_tmp);
  if ( ( $test && !test_file_exist($file) ) || ( $test && test_host_file( $file, $file_tmp ) ) ) {
    rename( "$file_tmp", "$file" );
  }
  else {
    if ( !$test ) {
      $error++;
    }
  }
  return $file;
} ## end sub create_host1_file

sub delete_file {
  my $file = shift;
  if ( -e $file ) {
    unlink "$file" or error_die("Unable to unlink $file: $!");
  }

} ## end sub delete_file

sub create_host2_file {
  my $file     = "$config_directory/config-HOST2.txt";
  my $file_tmp = "$config_directory/config-HOST2.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  my $iterace  = 1;
  if ($test) {
    delete_file($file_tmp);
  }
  my $file_in = "$config_directory/config-HOST1.txt";
  my @array   = get_array_data($file_in);

  foreach my $line (@array) {
    chomp $line;
    if ( $line eq "" || $line =~ /User for/ ) { next; }
    $line = remove_whitespace($line);
    if ( !( index( $line, "GROUP_NAME" ) > -1 ) ) {
      my @elements = split( " ", $line );
      $elements[0] = remove_whitespace( $elements[0] );
      $elements[2] = remove_whitespace( $elements[2] );
      my $port = "$elements[0] $elements[2]";
      `echo $port >> "$file_tmp"`;
      my $cmd      = "raidcom get lun -port $port $autetization";
      my $save_end = "save";
      if ( $iterace == 1 ) {
        my $file = "/dev/null";
        my $cmd  = "raidcom -login $login $paswd $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
      }
      $iterace++;
      if ( $iterace == 8 ) {
        my $file = "/dev/null";
        my $cmd  = "raidcom -logout $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
        $cmd = "raidcom -login $login $paswd $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
        $iterace = 2;
      } ## end if ( $iterace == 8 )
      cmd( $cmd, $file_tmp, $timeout_cmd_normal, $save_end );

      #my $test2 = correct_raidcom_command($file_tmp,$file);
      #if ($test2 != 0){
      #  return $file;
      #}
    } ## end if ( !( index( $line, ...)))
  } ## end foreach my $line (@array)
  my $file_null = "/dev/null";
  my $cmd_out   = "raidcom -logout $autetization";
  cmd( $cmd_out, $file_null, $timeout_cmd_low );
  $test = test_file_exist($file_tmp);
  if ( ( $test && !test_file_exist($file) ) || ( $test && test_host_file( $file, $file_tmp ) ) ) {
    rename( "$file_tmp", "$file" );
  }
  else {
    if ( !$test ) {
      $error++;
    }
  }
  return $file;
} ## end sub create_host2_file

sub create_host3_file {
  my $file     = "$config_directory/config-HOST3.txt";
  my $file_tmp = "$config_directory/config-HOST3.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  my $iterace  = 1;
  if ($test) {
    delete_file($file_tmp);
  }
  my $file_in = "$config_directory/config-HOST1.txt";
  my @array   = get_array_data($file_in);
  foreach my $line (@array) {
    chomp $line;
    if ( $line eq "" || $line =~ /User for/ ) { next; }
    $line = remove_whitespace($line);
    if ( !( index( $line, "GROUP_NAME" ) > -1 ) ) {
      my @elements = split( " ", $line );
      $elements[0] = remove_whitespace( $elements[0] );
      $elements[2] = remove_whitespace( $elements[2] );
      my $port = "$elements[0] $elements[2]";
      `echo $port >> "$file_tmp"`;
      my $cmd      = "raidcom get hba_wwn -port $port $autetization";
      my $save_end = "save";
      if ( $iterace == 1 ) {
        my $file = "/dev/null";
        my $cmd  = "raidcom -login $login $paswd $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
      }
      $iterace++;
      if ( $iterace == 8 ) {
        my $file = "/dev/null";
        my $cmd  = "raidcom -logout $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
        $cmd = "raidcom -login $login $paswd $autetization";
        cmd( $cmd, $file, $timeout_cmd_low );
        $iterace = 2;
      } ## end if ( $iterace == 8 )
      cmd( $cmd, $file_tmp, $timeout_cmd_normal, $save_end );

      #my $test2 = correct_raidcom_command($file_tmp,$file);
      #if ($test2 != 0){
      #return $file;
      #}
    } ## end if ( !( index( $line, ...)))
  } ## end foreach my $line (@array)
  my $file_null = "/dev/null";
  my $cmd_out   = "raidcom -logout $autetization";
  cmd( $cmd_out, $file_null, $timeout_cmd_low );
  $test = test_file_exist($file_tmp);
  if ( ( $test && !test_file_exist($file) ) || ( $test && test_host_file( $file, $file_tmp ) ) ) {
    rename( "$file_tmp", "$file" );
  }
  else {
    if ( !$test ) {
      $error++;
    }
  }
  return $file;
} ## end sub create_host3_file

sub get_data_host_cfg4 {
  my ( $tmp_host, $section ) = @_;
  my %host = %{$tmp_host};
  my %host_inventory;
  my $name_host = "";
  my $id_luns   = "";
  my @hosts;
  my @vol;

  foreach my $port ( keys %{ $host{$section}{PORT} } ) {
    foreach my $group ( keys %{ $host{$section}{PORT}{$port}{GROUP} } ) {
      foreach my $host ( keys %{ $host{$section}{PORT}{$port}{GROUP}{$group}{HOST} } ) {

        #print $host . "\n";
        if ( !defined $host_inventory{$section}{HOST}{$host} ) {
          $host_inventory{$section}{HOST}{$host}{NAME} = $host;
          $name_host = $host;
        }
        else {
          $name_host = $host;
        }
        if ( !defined $host_inventory{$section}{HOST}{$name_host}{GROUP}{$group} ) {
          $host_inventory{$section}{HOST}{$name_host}{GROUP}{$group}{NAME} = $group;
        }
        if ( !defined $host_inventory{$section}{HOST}{$name_host}{PORT}{$port} ) {
          $host_inventory{$section}{HOST}{$name_host}{PORT}{$port}{NAME} = $port;
        }

        foreach my $lun ( keys %{ $host{$section}{PORT}{$port}{GROUP}{$group}{LUN} } ) {    # LUN
          if ( !defined $host_inventory{$section}{HOST}{$name_host}{LUN}{$lun} && $name_host ne "" ) {
            $host_inventory{$section}{HOST}{$name_host}{LUN}{$lun}{ID} = $lun;
          }
        }

        foreach my $ldev ( keys %{ $host{$section}{PORT}{$port}{GROUP}{$group}{LDEV} } ) {    # LDEV
          if ( !defined $host_inventory{$section}{HOST}{$name_host}{LDEV}{$ldev} && $name_host ne "" ) {
            $host_inventory{$section}{HOST}{$name_host}{LDEV}{$ldev}{ID} = $ldev;
          }
        }

      } ## end foreach my $host ( keys %{ ...})
    } ## end foreach my $group ( keys %{...})
  } ## end foreach my $port ( keys %{ ...})
  $name_host = "";

  foreach my $host ( keys %{ $host_inventory{$section}{HOST} } ) {
    if ( defined $host_inventory{$section}{HOST}{$host}{NAME} ) {
      $name_host = $host_inventory{$section}{HOST}{$host}{NAME};
    }
    else {
      next;
    }

    foreach my $lun ( keys %{ $host_inventory{$section}{HOST}{$host}{LDEV} } ) {
      my $id_lun = "";
      if ( defined $host_inventory{$section}{HOST}{$host}{LDEV}{$lun}{ID} ) {

        # convert ldev_name to hexa
        $id_lun = $host_inventory{$section}{HOST}{$host}{LDEV}{$lun}{ID};
      }
      if ( $id_lun ne "" ) {
        my $hex = sprintf( "0x%x", $id_lun );
        $hex =~ s/x//g;
        my $len = length($hex);
        if ( $len < 6 ) {
          my $add_null = 6 - $len;
          for ( my $i = 0; $i < $add_null; $i++ ) {
            $hex = "0$hex";
          }
        } ## end if ( $len < 6 )
        my @chars = split( "", $hex );
        $hex = "$chars[0]$chars[1]:$chars[2]$chars[3]:$chars[4]$chars[5]";
        my $uc = uc($hex);
        $id_lun                                                = $uc;
        $host_inventory{$section}{HOST}{$host}{LDEV}{$lun}{ID} = $id_lun;
        $id_luns                                               = $id_luns . " " . $id_lun;

        #if (!grep { $id_lun == $_ } @vol) {
        if ( !grep { $id_lun eq $_ } @vol ) {

          #push(@volumes,"$id_lun,,,,,,,,,,,,,,,,,,,,,\n"); ### seznam LDEV
          push( @vol, $id_lun );
        }
      } ## end if ( $id_lun ne "" )
    } ## end foreach my $lun ( keys %{ $host_inventory...})
    if ( $name_host ne "" ) {
      $id_luns =~ s/ //;
      push( @hosts, ",,$name_host,,,,,$id_luns,\n" );
      $id_luns   = "";
      $name_host = "";
    } ## end if ( $name_host ne "" )
  } ## end foreach my $host ( keys %{ ...})

  #my @sort_volumes = sort { $a cmp $b } @vol;
  my @sort_volumes = sort { $a cmp $b } @vol;
  foreach my $id_volume (@sort_volumes) {
    push( @volumes, "$id_volume,,,,,,,,,,,,,,,,,,,,,\n" );    ### seznam volumes
  }

  ### section Mapping
  my $inv_lun  = "";
  my $inv_port = "";
  my $inv_grp  = "";
  my $inv_host = "";
  my $inv_ldev = "";

  foreach my $host ( keys %{ $host_inventory{$section}{HOST} } ) {
    if ( !defined $host_inventory{$section}{HOST}{$host}{NAME} ) {
      next;
    }
    else {
      $inv_host = $host_inventory{$section}{HOST}{$host}{NAME};
    }

    foreach my $group ( keys %{ $host_inventory{$section}{HOST}{$host}{GROUP} } ) {
      if ( !defined $host_inventory{$section}{HOST}{$host}{GROUP}{$group}{NAME} ) {
        next;
      }
      else {
        $inv_grp = $inv_grp . " " . $host_inventory{$section}{HOST}{$host}{GROUP}{$group}{NAME};
      }

    } ## end foreach my $group ( keys %{...})

    foreach my $port ( keys %{ $host_inventory{$section}{HOST}{$host}{PORT} } ) {
      if ( !defined $host_inventory{$section}{HOST}{$host}{PORT}{$port}{NAME} ) {
        next;
      }
      else {
        $inv_port = $inv_port . " " . $host_inventory{$section}{HOST}{$host}{PORT}{$port}{NAME};
      }

    } ## end foreach my $port ( keys %{ ...})

    #foreach my $lun (keys %{$host_inventory{$section}{HOST}{$host}{LUN}}){
    # if (!defined $host_inventory{$section}{HOST}{$host}{LUN}{$lun}{ID}){
    #   next;
    # }
    # else{
    #   $inv_lun = $inv_lun . " " . $host_inventory{$section}{HOST}{$host}{LUN}{$lun}{ID};
    # }
    #
    #}

    foreach my $ldev ( keys %{ $host_inventory{$section}{HOST}{$host}{LDEV} } ) {
      if ( !defined $host_inventory{$section}{HOST}{$host}{LDEV}{$ldev}{ID} ) {
        next;
      }
      else {
        $inv_ldev = $inv_ldev . " " . $host_inventory{$section}{HOST}{$host}{LDEV}{$ldev}{ID};
      }

    } ## end foreach my $ldev ( keys %{ ...})

    $inv_lun =~ s/ //;
    $inv_port =~ s/ //;
    $inv_grp =~ s/ //;
    $inv_ldev =~ s/ //;

    if ( $inv_host ne "" ) {
      push( @mapping, "$inv_host,$inv_grp,$inv_port,$inv_ldev\n" );
    }

    $inv_lun  = "";
    $inv_port = "";
    $inv_grp  = "";
    $inv_host = "";
    $inv_ldev = "";

  } ## end foreach my $host ( keys %{ ...})

  ###

  #print Dumper \@mapping;
  #print Dumper \%host_inventory;
  #print Dumper \@volumes;
  return @hosts;

} ## end sub get_data_host_cfg4

sub get_metric_index {
  my ( $header_tmp, $section, $key_element ) = @_;
  my %header = %{$header_tmp};
  my $index  = 0;

  foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
    my $name = $header{$section}{$id}{NAME};
    if ( "$name" eq "$key_element" ) {
      return $index;
    }
    $index++;
  } ## end foreach my $id ( sort { $a ...})
  return -1;

} ## end sub get_metric_index

sub get_data_host_cfg3 {
  my ( $file, $section, $metric, $tmp_host ) = @_;
  my %host = %{$tmp_host};
  my @metrics = split( ",", $metric );

  my @data = get_array_data($file);
  my %header;
  my $key_header = "PORT";
  my $group_name = "";

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }

    if ( $line =~ /$key_header / ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;

        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
      foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
        if ( !defined $header{$section}{$id}{LENGTH} && defined $header{$section}{$id}{START} ) {
          $header{$section}{$id}{LENGTH} = "LAST";
          last;
        }
      } ## end foreach my $id ( sort { $a ...})

    } ## end if ( $line =~ /$key_header/)
    else {
      if ( $line =~ /User for/ ) { next; }
      my ( $port, $group, $gid ) = split( " ", $line );

      #my $group_name = "";
      my $nick = "";

      #my $port_name = "";
      if ( !defined $host{$section}{PORT}{$port}{GROUP}{$group}{NAME} && defined($gid) ) {
        delete( $host{$section}{PORT}{$port}{GROUP}{$group} );    ### odstranit spatne groupy ktere se tvori predchozi podminkou
                                                                  #print "radky z daty\n";
        if ( defined $header{$section} ) {
          foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
            if ( defined $header{$section}{$id}{LENGTH} ) {
              my $name = $header{$section}{$id}{NAME};
              if ( $name ne "PORT" && $name ne "GROUP_NAME" && $name ne "NICK_NAME" ) { next; }
              my $start  = $header{$section}{$id}{START};
              my $length = $header{$section}{$id}{LENGTH};
              if ( $length eq "LAST" ) {
                $length = length $line;
              }
              if ( $start == 0 ) { $length--; }
              my $value = substr( $line, $start, $length );
              $value = remove_whitespace($value);
              if ( $name eq "PORT" ) {
                $port = $value;

              }

              #if ($name eq "GROUP_NAME"){
              #  $group = $value;
              #
              #}
              if ( $name eq "NICK_NAME" ) {
                my @values = split( " ", $line );
                my $size_v = scalar @values;
                my $size_e = scalar @metrics;
                if ( $size_v == $size_e ) {
                  my $index = get_metric_index( \%header, $section, $name );
                  if ( $index != -1 ) {
                    $nick = $values[$index];
                    $nick = remove_whitespace($nick);
                  }
                  else {
                    $nick = $value;
                  }
                } ## end if ( $size_v == $size_e)
                else {
                  $nick = $value;
                }
              } ## end if ( $name eq "NICK_NAME")

              #print "$group_name ... $nick ... $port\n";
              if ( $group_name ne "" && $nick ne "" && $port ne "" && $nick ne "-" ) {
                $host{$section}{PORT}{$port}{GROUP}{$group_name}{HOST}{$nick}{ID} = $nick;
                $nick = "";

                #$group = "";
                $port = "";
                last;
              } ## end if ( $group_name ne ""...)
            } ## end if ( defined $header{$section...})
          } ## end foreach my $id ( sort { $a ...})
        } ## end if ( defined $header{$section...})
      } ## end if ( !defined $host{$section...})
      else {
        $group_name = $group;

      }

    } ## end else [ if ( $line =~ /$key_header/)]

  } ## end foreach my $line (@data)
  foreach my $port ( keys %{ $host{$section}{PORT} } ) {
    foreach my $group ( keys %{ $host{$section}{PORT}{$port}{GROUP} } ) {
      if ( !defined $host{$section}{PORT}{$port}{GROUP}{$group}{HOST} ) {
        if ( defined $host{$section}{PORT}{$port}{GROUP}{$group}{LDEV} ) {
          $host{$section}{PORT}{$port}{GROUP}{$group}{HOST}{$group}{ID} = $group;
        }
        else {
          delete $host{$section}{PORT}{$port}{GROUP}{$group}{LDEV};
        }
      } ## end if ( !defined $host{$section...})
    } ## end foreach my $group ( keys %{...})
  } ## end foreach my $port ( keys %{ ...})

  #print Dumper \%host;
  #print Dumper \%header;
  #print Dumper \%host;
  return %host;

} ## end sub get_data_host_cfg3

sub get_data_host_cfg2 {
  my ( $file, $section, $metric, $tmp_host ) = @_;

  #my @data = @{$data_tmp};
  #my $file = shift;
  #my $section = shift;
  #my $metric = shift;
  my %host = %{$tmp_host};
  my @metrics = split( ",", $metric );

  my @data = get_array_data($file);
  my %header;
  my $key_header = "PORT";
  my $group_name = "";

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }

    #print "$line\n";
    if ( $line =~ /$key_header/ ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;

        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
    } ## end if ( $line =~ /$key_header/)
    else {
      if ( $line =~ /User for/ ) { next; }
      ### port_name a $group_name dat nekde vys abychom vedeli hlavne do jake groupy to dat
      my ( $port, $group, $hmd ) = split( " ", $line );
      my $lun_name  = "";
      my $ldev_name = "";
      if ( !defined $host{$section}{PORT}{$port}{GROUP}{$group}{NAME} && defined($hmd) ) {
        delete( $host{$section}{PORT}{$port}{GROUP}{$group} );    ### odstranit spatne groupy ktere se tvori predchozi podminkou
                                                                  #print "radky z daty\n";
                                                                  #print "$line\n";
        if ( defined $header{$section} ) {
          foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
            if ( defined $header{$section}{$id}{LENGTH} ) {
              my $name = $header{$section}{$id}{NAME};
              if ( $name ne "PORT" && $name ne "LUN" && $name ne "LDEV" ) { next; }
              my $start  = $header{$section}{$id}{START};
              my $length = $header{$section}{$id}{LENGTH};
              if ( $start == 0 ) { $length--; }
              my $value = substr( $line, $start, $length );

              #exception LDEV NAME#
              my @chars = split( "", $line );
              $value = remove_whitespace($value);
              if ( $name eq "PORT" ) {
                $port = $value;

              }
              if ( $name eq "LDEV" ) {
                $ldev_name = $value;
                if ( $start != 0 && $chars[ $start - 1 ] ne "" && $chars[ $start - 1 ] ne " " ) {
                  $ldev_name = "$chars[$start-1]" . "$ldev_name";
                }

              } ## end if ( $name eq "LDEV" )
              if ( $name eq "LUN" ) {
                $lun_name = $value;

              }
              if ( $lun_name ne "" && $ldev_name ne "" && $port ne "" ) {
                $host{$section}{PORT}{$port}{GROUP}{$group_name}{LUN}{$lun_name}{ID}   = $lun_name;
                $host{$section}{PORT}{$port}{GROUP}{$group_name}{LDEV}{$ldev_name}{ID} = $ldev_name;
                $lun_name                                                              = "";
                $ldev_name                                                             = "";
                last;
              } ## end if ( $lun_name ne "" &&...)
            } ## end if ( defined $header{$section...})
          } ## end foreach my $id ( sort { $a ...})
        } ## end if ( defined $header{$section...})
      } ## end if ( !defined $host{$section...})
      else {
        $group_name = $group;

      }

    } ## end else [ if ( $line =~ /$key_header/)]

  } ## end foreach my $line (@data)

  #print Dumper \%header;
  return %host;

} ## end sub get_data_host_cfg2

sub get_data_host_cfg1 {
  my $file    = shift;
  my $section = shift;
  my $metric  = shift;
  my @metrics = split( ",", $metric );

  my @data = get_array_data($file);
  my %header;
  my $key_header = "PORT";
  my %hash_host;
  my $port_name = "";

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }
    if ( $line =~ /$key_header/ ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;

        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
    } ## end if ( $line =~ /$key_header/)
    else {
      if ( $line =~ /User for/ ) { next; }
      if ( defined $header{$section} ) {
        foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
          if ( defined $header{$section}{$id}{LENGTH} ) {
            my $name = $header{$section}{$id}{NAME};
            if ( $name ne "PORT" && $name ne "GROUP_NAME" ) { next; }
            my $start  = $header{$section}{$id}{START};
            my $length = $header{$section}{$id}{LENGTH};
            if ( $start == 0 ) { $length--; }
            my $value = substr( $line, $start, $length );
            $value = remove_whitespace($value);
            if ( $name eq "PORT" ) {

              if ( !defined $hash_host{$section}{PORT}{$value}{NAME} ) {
                $hash_host{$section}{PORT}{$value}{NAME} = $value;
                $port_name = $value;
              }
            } ## end if ( $name eq "PORT" )
            if ( $name eq "GROUP_NAME" && $port_name ne "" ) {
              if ( !defined $hash_host{$section}{PORT}{$port_name}{GROUP}{$value}{NAME} ) {
                $hash_host{$section}{PORT}{$port_name}{GROUP}{$value}{NAME} = $value;
              }
            }
          } ## end if ( defined $header{$section...})
        } ## end foreach my $id ( sort { $a ...})
      } ## end if ( defined $header{$section...})
    } ## end else [ if ( $line =~ /$key_header/)]
  } ## end foreach my $line (@data)

  #print Dumper \%hash_host;
  return %hash_host;

} ## end sub get_data_host_cfg1

sub set_data_ldev {
  my $file_ldev = create_ldev_file();
  my $section   = "Volume Level Configuration";

  #my $header = "ldev_id,name,,,,,pool_id,,capacity (MB),,,,,,,,,,,,interface_type,raid_group_id,tier1 (MB),tier2 (MB),tier3 (MB)";
  my $header = "volume_id,name,,,,,pool_id,,capacity (MB),,,,,,,,,,,,interface_type,raid_group_id";

  #my $metric = "LDEV,VOL_Capacity(BLK),F_POOLID,B_POOLID,LDEV_NAMING,Used_Block(BLK),TIER#1(MB),TIER#2(MB),TIER#3(MB),NUM_GROUP,RAID_GROUPs";
  my $metric = "LDEV,VOL_Capacity(BLK),F_POOLID,B_POOLID,LDEV_NAMING,Used_Block(BLK),NUM_GROUP,RAID_GROUPs";
  my @data = get_data_ldev( $file_ldev, $section, $metric );
  set_write_data( $section, $header, \@data );

} ## end sub set_data_ldev

sub create_ldev_file {
  my $file     = "$config_directory/config-LDEV.txt";
  my $file_tmp = "$config_directory/config-LDEV.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }

  my $cmd = "raidcom get ldev -ldev_list defined -fx $autetization";
  cmd( $cmd, $file_tmp, $timeout_cmd_high );
  $test = test_file_exist($file_tmp);
  if ($test) {
    my $test2 = correct_raidcom_command($file_tmp);
    if ( $test2 == 0 ) {
      rename( "$file_tmp", "$file" );
    }
  } ## end if ($test)
  else {
    $error++;
  }
  return $file;
} ## end sub create_ldev_file

sub create_pool1_file {
  my $file     = "$config_directory/config-POOL1.txt";
  my $file_tmp = "$config_directory/config-POOL1.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }

  my $cmd = "raidcom get pool -key opt $autetization";
  cmd( $cmd, $file_tmp, $timeout_cmd_normal );
  $test = test_file_exist($file_tmp);
  if ($test) {
    my $test2 = correct_raidcom_command($file_tmp);
    if ( $test2 == 0 ) {
      rename( "$file_tmp", "$file" );
    }
  } ## end if ($test)

  #else{
  #  #$error++; HUS-VM do not have this configuration
  #}
  return $file;

} ## end sub create_pool1_file

sub create_pool2_file {
  my $file     = "$config_directory/config-POOL2.txt";
  my $file_tmp = "$config_directory/config-POOL2.txt-tmp";
  my $test     = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }

  my $cmd = "raidcom get pool $autetization";
  cmd( $cmd, $file_tmp, $timeout_cmd_normal );
  $test = test_file_exist($file_tmp);
  if ($test) {
    my $test2 = correct_raidcom_command($file_tmp);
    if ( $test2 == 0 ) {
      rename( "$file_tmp", "$file" );
    }
  } ## end if ($test)
  else {
    $error++;
  }
  return $file;
} ## end sub create_pool2_file

sub get_data_ldev {
  my $file    = shift;
  my $section = shift;
  my $metric  = shift;
  my @metrics = split( ",", $metric );

  my @data = get_array_data($file);
  my %header;
  my $key_header = "GROUP";
  my @array_ldev;
  my $active  = 0;
  my $ldev_id = "";

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) {
      $active  = 0;
      $ldev_id = "";
      next;
    }
    $line = remove_whitespace($line);

    if ( index( $line, "Serial" ) > -1 ) {
      $active = 1;
      next;
    }
    foreach my $element (@metrics) {
      if ( index( $line, $element ) > -1 && $active == 1 ) {

        my @array_line = split( ":", $line );
        my $header_element = "";
        foreach my $array_element (@array_line) {
          chomp $array_element;
          $array_element =~ s/VIR_LDEV//g;    ### virtual ldev
          $array_element = remove_whitespace($array_element);
          if ( index( $array_element, $element ) > -1 ) {
            $header_element = $array_element;
            next;
          }
          if ( $header_element eq "LDEV" ) {
            $ldev_id = $array_element;
            my $len = length($ldev_id);
            if ( $len < 6 ) {
              my $add_null = 6 - $len;
              for ( my $i = 0; $i < $add_null; $i++ ) {
                $ldev_id = "0$ldev_id";
              }
            } ## end if ( $len < 6 )
            my @chars = split( "", $ldev_id );
            $ldev_id = "$chars[0]$chars[1]:$chars[2]$chars[3]:$chars[4]$chars[5]";
            my $uc = uc($ldev_id);
            $ldev_id = $uc;
            $header{$section}{$ldev_id}{ID} = $ldev_id;
            next;
          } ## end if ( $header_element eq...)
          if ( $header_element eq "VOL_Capacity(BLK)" && $ldev_id ne "" ) {
            my $transfer_cap = ( $array_element * 512 ) / ( 1024 * 1024 );
            $array_element = round($transfer_cap);
            $header{$section}{$ldev_id}{CAPACITY} = $array_element;
            next;
          } ## end if ( $header_element eq...)
          if ( $header_element eq "F_POOLID" && $ldev_id ne "" ) {
            $header{$section}{$ldev_id}{FPOOL_ID} = $array_element;
            next;
          }
          if ( $header_element eq "B_POOLID" && $ldev_id ne "" ) {
            $header{$section}{$ldev_id}{BPOOL_ID} = $array_element;
            next;
          }
          if ( $header_element eq "LDEV_NAMING" && $ldev_id ne "" ) {
            $header{$section}{$ldev_id}{NAME} = $array_element;
            next;
          }
          if ( $header_element eq "Used_Block(BLK)" && $ldev_id ne "" ) {
            my $transfer_cap = ( $array_element * 512 ) / ( 1024 * 1024 );
            $array_element = round($transfer_cap);
            $header{$section}{$ldev_id}{USED_CAPACITY} = $array_element;
            next;
          } ## end if ( $header_element eq...)

          #if ($header_element eq "TIER#1(MB)" && $ldev_id ne ""){
          #  $header{$section}{$ldev_id}{"TIER1(MB)"} = $array_element;
          #  next;
          #}
          #if ($header_element eq "TIER#2(MB)" && $ldev_id ne ""){
          #  $header{$section}{$ldev_id}{"TIER2(MB)"} = $array_element;
          #  next;
          #}
          #if ($header_element eq "TIER#3(MB)" && $ldev_id ne ""){
          #  $header{$section}{$ldev_id}{"TIER3(MB)"} = $array_element;
          #  next;
          #}

          if ( $header_element eq "NUM_GROUP" && $ldev_id ne "" ) {
            $header{$section}{$ldev_id}{"$header_element"} = $array_element;
            next;
          }
          if ( $header_element eq "RAID_GROUPs" && $ldev_id ne "" ) {
            if ( $header{$section}{$ldev_id}{"NUM_GROUP"} == 1 ) {
              $header{$section}{$ldev_id}{"$header_element"} = $array_element;
              next;
            }
            else {
              $header{$section}{$ldev_id}{"$header_element"}{"$array_element"}{"ID"} = $array_element;
              next;
            }
          } ## end if ( $header_element eq...)

        } ## end foreach my $array_element (...)
        last;
      } ## end if ( index( $line, $element...))

    } ## end foreach my $element (@metrics)

  } ## end foreach my $line (@data)

  #print Dumper \%header;
  foreach my $id ( sort keys %{ $header{$section} } ) {
    my $name;
    my $pool_id;
    my $cap;
    my $raid_gr = "";
    my $tier1;
    my $tier2;
    my $tier3;
    if ( defined $header{$section}{$id}{FPOOL_ID} ) {    ### remove pool-volumes

      if ( $header{$section}{$id}{FPOOL_ID} ne "NONE" ) {

        #delete $header{$section}{$id};
        next;
      } ## end if ( $header{$section}...)
    } ## end if ( defined $header{$section...})
    else {
      if ( defined $header{$section}{$id} ) {

        #delete $header{$section}{$id};
        next;
      }
    } ## end else [ if ( defined $header{$section...})]
    if ( defined $header{$section}{$id}{ID} ) {
      $id = $header{$section}{$id}{ID};
    }
    else {
      $id = "";
    }
    if ( defined $header{$section}{$id}{NAME} ) {

      #$name = $header{$section}{$id}{NAME};
      $name = "";
    }
    else {
      $name = "";
    }

    #if (defined $header{$section}{$id}{FPOOL_ID}){
    #  if ($header{$section}{$id}{FPOOL_ID} ne "NONE"){
    #    $pool_id = $header{$section}{$id}{FPOOL_ID};
    #  }
    #  else{
    #    $pool_id = "";
    #  }
    #}
    if ( defined $header{$section}{$id}{BPOOL_ID} && isdigit( $header{$section}{$id}{BPOOL_ID} ) ) {
      $pool_id = $header{$section}{$id}{BPOOL_ID};
    }
    else {
      if ( defined $header{$section}{$id}{BPOOL_ID} && !isdigit( $header{$section}{$id}{BPOOL_ID} ) ) {
        $pool_id = "-1";
      }
      else {
        $pool_id = "";
      }
    } ## end else [ if ( defined $header{$section...})]
    if ( defined $header{$section}{$id}{CAPACITY} ) {
      $cap = $header{$section}{$id}{CAPACITY};
    }
    else {
      $cap = "";
    }

    if ( defined $header{$section}{$id}{NUM_GROUP} ) {
      if ( $header{$section}{$id}{NUM_GROUP} == 1 ) {
        $raid_gr = $header{$section}{$id}{RAID_GROUPs};
      }
      else {
        foreach my $gr ( sort keys %{ $header{$section}{$id}{RAID_GROUPs} } ) {
          $raid_gr = $raid_gr . " " . $header{$section}{$id}{RAID_GROUPs}{$gr}{ID};
        }
      }
    } ## end if ( defined $header{$section...})
    else {
      $raid_gr = "";
    }

    #if (defined $header{$section}{$id}{"TIER1(MB)"}){
    #  $tier1 = $header{$section}{$id}{"TIER1(MB)"};
    #}
    #else{
    #  $tier1 = "";
    #}
    #if (defined $header{$section}{$id}{"TIER2(MB)"}){
    #  $tier2 = $header{$section}{$id}{"TIER2(MB)"};
    #}
    #else{
    #  $tier2 = "";
    #}
    #if (defined $header{$section}{$id}{"TIER3(MB)"}){
    #  $tier3 = $header{$section}{$id}{"TIER3(MB)"};
    #}
    #else{
    #  $tier3 = "";
    #}

    #my $header = "ldev_id,name,,,,,pool_id,,capacity (MB),,,,,,,,,,,,interface_type,raid_group_id,tier1 (MB),tier2 (MB),tier3 (MB)";
    if ( $pool_id eq "" ) {
      $pool_id = -1;    ## default pool
    }
    my $test_file = "$wrkdir/VOLUME/$id\.rrd";
    my $vol_cfg   = "$wrkdir/VOLUME/volumes.cfg";
    if ( test_file_exist($vol_cfg) ) {
      if ( test_file_exist($test_file) ) {
        push( @array_ldev, "$id,$name,,,,,$pool_id,,$cap,,,,,,,,,,,,,$raid_gr\n" );
      }
    }
    else {
      push( @array_ldev, "$id,$name,,,,,$pool_id,,$cap,,,,,,,,,,,,,$raid_gr\n" );
    }
  } ## end foreach my $id ( sort keys ...)

  ### add to ldev inventory ldev which it has rrd files and it is not in ldev config
  my @inventory_ldev = <$wrkdir/VOLUME/*.rrd>;
  foreach my $file (@inventory_ldev) {
    chomp $file;
    if ( $file eq "" ) { next; }
    my $name = basename($file);
    $name =~ s/\.rrd//g;
    my $test = grep {/^$name/} @array_ldev;
    if ( $test == 0 ) {
      push( @array_ldev, "$name,,,,,,-1,,,,,,,,,,,,,,,\n" );
    }
  } ## end foreach my $file (@inventory_ldev)

  #print Dumper \@array_ldev;
  #print Dumper \%header;
  return @array_ldev;

} ## end sub get_data_ldev

sub basename {
  my $full = shift;
  my $out  = "";

  # basename without direct function
  my @base = split( /\//, $full );
  foreach my $m (@base) {
    $out = $m;
  }

  return $out;
} ## end sub basename

sub isdigit {
  my $digit = shift;
  my $text  = shift;

  if ( !defined($digit) ) {
    return 0;
  }
  if ( $digit eq '' ) {
    return 0;
  }

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;
  $digit_work =~ s/^-//;
  $digit_work =~ s/e//;
  $digit_work =~ s/\+//;
  $digit_work =~ s/\-//;

  if ( length($digit_work) == 0 ) {

    # is a number
    return 1;
  }

  #if (($digit * 1) eq $digit){
  #  # is a number
  #  return 1;
  #}

  # NOT a number
  return 0;
} ## end sub isdigit

sub round {
  my $number = shift;
  my $num    = $number;
  if ( $number =~ /\./ ) {
    $number =~ s/.*\.//g;
    my $length = length($number);
    if ( $length > 3 ) {
      my $rounded = sprintf( "%.3f", $num );
      return $rounded;
    }
    else {
      return $num;
    }
  } ## end if ( $number =~ /\./ )
  else {
    return $num;
  }
} ## end sub round

sub get_total_cap_rg {
  my ($data_tmp)  = @_;
  my @data        = @{$data_tmp};
  my $active      = 0;
  my $index_group = "";
  my $index_lba   = "";
  my %rg_cap;

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) {
      $active = 0;
      next;
    }
    $line = remove_whitespace($line);
    if ( $line =~ /GROUP/ && $line =~ /SIZE_LBA/ ) {
      $index_group = "";
      $index_lba   = "";
      my @header = split( " ", $line );
      my $index = -1;
      foreach my $element (@header) {
        chomp $element;
        $index++;
        if ( $element eq "" ) { next; }
        $element = remove_whitespace($element);
        if ( $element eq "GROUP" ) {
          $index_group = $index;
        }
        if ( $element eq "SIZE_LBA" ) {
          $index_lba = $index;
        }
      } ## end foreach my $element (@header)
      if ( $index_group ne "" && $index_lba ne "" ) {
        $active = 1;
        next;
      }
    } ## end if ( $line =~ /GROUP/ ...)
    if ( $active == 1 ) {
      my @header = split( " ", $line );
      chomp $header[$index_group];
      chomp $header[$index_lba];
      my $name      = remove_whitespace( $header[$index_group] );
      my $lba       = remove_whitespace( $header[$index_lba] );
      my $total_cap = "";
      {
        no warnings;
        $total_cap = round( ( hex($lba) * 512 ) / ( 1024 * 1024 * 1024 ) );
      }
      if ( defined $rg_cap{"$name"} ) {
        my $cap = $rg_cap{"$name"};
        $rg_cap{"$name"} = $cap + $total_cap;
      }
      else {
        $rg_cap{"$name"} = $total_cap;
      }
    } ## end if ( $active == 1 )
  } ## end foreach my $line (@data)

  return %rg_cap;
} ## end sub get_total_cap_rg

sub get_data_rg {
  my $file    = shift;
  my $file2   = shift;
  my $section = shift;
  my $metric  = shift;
  my @metrics = split( ",", $metric );

  my @data     = get_array_data($file);
  my @data_cap = get_array_data($file2);
  my %header;
  my $key_header = "GROUP";
  my @array_rg;
  my %total_capacity = get_total_cap_rg( \@data_cap );

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }
    if ( $line =~ /$key_header/ ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;

        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
    } ## end if ( $line =~ /$key_header/)
    else {
      if ( $line =~ /User for/ ) { next; }
      my $group        = "";
      my $size_usage   = "";
      my $size_free    = "";
      my $percent_free = "";
      if ( defined $header{$section} ) {
        foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
          if ( defined $header{$section}{$id}{LENGTH} ) {
            my $name = $header{$section}{$id}{NAME};
            if ( $name ne "GROUP" && $name ne "U(%)" && $name ne "AV_CAP(GB)" ) { next; }
            my $start  = $header{$section}{$id}{START};
            my $length = $header{$section}{$id}{LENGTH};
            if ( $start == 0 ) { $length--; }
            my $value = substr( $line, $start, $length );
            $value = remove_whitespace($value);

            if ( $name eq "GROUP" ) {
              $group = $value;
            }
            if ( $name eq "AV_CAP(GB)" ) {
              $size_free = $value;
            }

            if ( $name eq "U(%)" ) {
              my $percent = $value;
              $percent_free = 100 - $percent;
            }
          } ## end if ( defined $header{$section...})
        } ## end foreach my $id ( sort { $a ...})
        if ( ( $size_free == 0 && defined $total_capacity{$group} && $percent_free == 0 ) || ( defined $total_capacity{$group} && $size_free == 0 && $percent_free != 0 ) ) {

          #my $total_cap = (100/$percent_free) * $size_free;
          #$total_cap = round($total_cap);
          my $total_cap = $total_capacity{$group};
          $size_free  = 0;
          $size_usage = $total_cap;
          push( @array_rg, ",$group,,,,$total_cap,,$size_free,,$size_usage,,,,,,,,\n" );
        } ## end if ( ( $size_free == 0...))
        else {
          if ( defined $total_capacity{$group} ) {
            my $total_cap = $total_capacity{$group};

            #$size_free = ($percent_free/100) * $total_cap;
            $size_usage = $total_cap - $size_free;
            push( @array_rg, ",$group,,,,$total_cap,,$size_free,,$size_usage,,,,,,,,\n" );
          } ## end if ( defined $total_capacity...)
          else {
            push( @array_rg, ",$group,,,,,,,,,,,,,,,,\n" );
          }
        } ## end else [ if ( ( $size_free == 0...))]

      } ## end if ( defined $header{$section...})
    } ## end else [ if ( $line =~ /$key_header/)]
  } ## end foreach my $line (@data)

  #print Dumper \%header;
  return @array_rg;

  #print "$line\n";
} ## end sub get_data_rg

sub remove_whitespace {
  my $value = shift;
  if (!defined $value){
    return "";
  }
  $value =~ s/^\s+|\s+$//g;
  return $value;

} ## end sub remove_whitespace

sub set_write_data {
  my ( $section, $header, $data_tmp ) = @_;
  my @data = @{$data_tmp};

  open( DATA, ">>$file_tmp" ) or error_die("Cannot open file: $file_tmp : $!");
  print DATA $section;
  print DATA "\n";
  print DATA get_separator($section);
  print DATA "\n";
  print DATA $header;
  print DATA "\n";
  print DATA @data;
  print DATA "\n";
  close(DATA);

} ## end sub set_write_data

sub set_configuration_header {
  my $section = "Configuration Data";
  my $header  = "";
  my $file    = create_configuration_info();
  my $file2   = create_configuration_info2();
  my $metric  = "RS_GROUP,RGID,V_Serial#,V_ID,V_IF,Serial#";
  my $metric2 = "No,Group,Hostname,HORCM_ver,Uid,Serial#,Micro_ver,Cache(MB)";
  my @data    = get_configuration_data( $section, $metric, $metric2, $file, $file2 );
  set_write_data( $section, $header, \@data );

} ## end sub set_configuration_header

sub get_configuration_data {
  my $section = shift;
  my $metric  = shift;
  my $metric2 = shift;
  my $file    = shift;
  my $file2   = shift;
  my @metrics = split( ",", $metric );
  my @data    = get_array_data($file);
  my @storage_info;
  my $key_header = "V_ID";
  my %header;

  foreach my $line (@data) {
    chomp $line;
    my @chars = split( "", $line );
    if ( $line eq "" ) { next; }
    if ( $line =~ /$key_header/ ) {
      my $prev;
      foreach my $element (@metrics) {
        if ( $element eq "Serial#" ) {
          $line =~ s/V_Serial#/V_serial#/g;    ### exeption index find wrong string-
        }
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;
        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
      foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
        if ( !defined $header{$section}{$id}{LENGTH} && defined $header{$section}{$id}{START} ) {
          $header{$section}{$id}{LENGTH} = "LAST";
          last;
        }
      } ## end foreach my $id ( sort { $a ...})

    } ## end if ( $line =~ /$key_header/)

    else {
      my $group_name         = "";
      my $serial_number_virt = "";
      my $storage_type       = "";
      my $serial_number      = "";
      if ( defined $header{$section} ) {
        foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
          if ( defined $header{$section}{$id}{LENGTH} ) {
            my $name = $header{$section}{$id}{NAME};
            if ( $name ne "V_Serial#" && $name ne "V_ID" && $name ne "Serial#" ) { next; }
            my $start  = $header{$section}{$id}{START};
            my $length = $header{$section}{$id}{LENGTH};
            if ( $length eq "LAST" ) {
              $length = length($line);
            }
            if ( $start == 0 ) { $length--; }
            my $value = substr( $line, $start, $length );
            $value = remove_whitespace($value);

            #if ($name eq "RS_GROUP"){
            #  $group_name = $value;
            #}
            if ( $name eq "V_Serial#" ) {
              $serial_number_virt = $value;
            }
            if ( $name eq "V_ID" ) {
              $storage_type = $value;
            }
            if ( $name eq "Serial#" ) {
              $serial_number = $value;
            }
          } ## end if ( defined $header{$section...})
        } ## end foreach my $id ( sort { $a ...})
        ### storage type ###
        #VSP G200: M8S
        #VSP G400, VSP G600, VSP F400, VSP F600: M8M
        #VSP G800, VSP F800: M8H
        #Virtual Storage Platform G1000: R8
        #Unified Storage VM: M7
        #Virtual Storage Platform: R7
        #Universal Storage Platform V: R6
        #Universal Storage Platform VM: RK6
        #TagmaStore USP: R5
        #TagmaStore NSC: RK5

        if ( $storage_type eq "M8S" ) {
          $storage_type = "VSP G200";
        }
        if ( $storage_type eq "M8M" ) {
          $storage_type = "VSP G400, VSP G600, VSP F400, VSP F600";
        }
        if ( $storage_type eq "M8H" ) {
          $storage_type = "VSP G800, VSP F800";
        }
        if ( $storage_type eq "R8" ) {
          $storage_type = "Virtual Storage Platform G1000";
        }
        if ( $storage_type eq "M7" ) {
          $storage_type = "Unified Storage VM";
        }
        if ( $storage_type eq "R7" ) {
          $storage_type = "Virtual Storage Platform";
        }
        if ( $storage_type eq "R6" ) {
          $storage_type = "Universal Storage Platform V";
        }
        if ( $storage_type eq "RK6" ) {
          $storage_type = "Universal Storage Platform VM";
        }
        if ( $storage_type eq "R5" ) {
          $storage_type = "TagmaStore USP";
        }
        if ( $storage_type eq "RK5" ) {
          $storage_type = "TagmaStore NSC";
        }

        push( @storage_info, "Machine Name: $STORAGE_NAME\n\n" );
        push( @storage_info, "Machine Type-Model: $storage_type\n\n" );

        #push(@storage_info,"Resource group name : $group_name\n");
        push( @storage_info, "Machine Serial: $serial_number\n\n" );
        push( @storage_info, "Machine Serial on the Virtual Mode: $serial_number_virt\n\n" );
        last;
      } ## end if ( defined $header{$section...})
    } ## end else [ if ( $line =~ /$key_header/)]
  } ## end foreach my $line (@data)

  @metrics    = split( ",", $metric2 );
  @data       = get_array_data($file2);
  $key_header = "Micro_ver";
  my $index = 0;
  my %header_element;

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }
    if ( $line =~ /$key_header/ ) {
      foreach my $element (@metrics) {
        my $index_i = index( $line, $element );
        if ( $index_i == -1 ) {
          next;
        }
        else {
          $header_element{$index} = $element;
          $index++;
        }
      } ## end foreach my $element (@metrics)
    } ## end if ( $line =~ /$key_header/)
    else {
      my @data_line = split( " ", $line );
      foreach my $index_header ( sort { $a <=> $b } keys %header_element ) {
        if ( $header_element{$index_header} eq "Micro_ver" ) {
          my $export_version = remove_whitespace( $data_line[$index_header] );
          push( @storage_info, "Export Tool Version: $export_version\n\n" );
        }
        if ( $header_element{$index_header} eq "HORCM_ver" ) {
          my $horcm_version = remove_whitespace( $data_line[$index_header] );
          push( @storage_info, "HORCM Version: $horcm_version\n\n" );
        }
        if ( $header_element{$index_header} eq "Hostname" ) {
          my $host = remove_whitespace( $data_line[$index_header] );
          $storage_info[0] = "Machine Name: $host\n\n";
        }
      } ## end foreach my $index_header ( ...)
      last;

    } ## end else [ if ( $line =~ /$key_header/)]

  } ## end foreach my $line (@data)

  return @storage_info;

} ## end sub get_configuration_data

sub create_configuration_info {
  my $file     = "$config_directory/config-STORAGE.txt";
  my $file_tmp = "$config_directory/config-STORAGE.txt-tmp";

  my $test = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }
  my $cmd = "raidcom get resource -key opt $autetization";
  cmd( $cmd, $file_tmp, $timeout_cmd_low );
  $test = test_file_exist($file_tmp);
  if ($test) {
    my $test2 = correct_raidcom_command($file_tmp);
    if ( $test2 == 0 ) {
      rename( "$file_tmp", "$file" );
    }
  } ## end if ($test)
  else {
    $error++;
  }

  return $file;
} ## end sub create_configuration_info

sub create_configuration_info2 {
  my $file     = "$config_directory/config-STORAGE_FIRMWARE.txt";
  my $file_tmp = "$config_directory/config-STORAGE_FIRMWARE.txt-tmp";

  my $test = test_file_exist($file_tmp);
  if ($test) {
    delete_file($file_tmp);
  }
  my $cmd = "raidqry -l $autetization";
  cmd( $cmd, $file_tmp, $timeout_cmd_low );
  $test = test_file_exist($file_tmp);
  if ($test) {
    my $test2 = correct_raidcom_command($file_tmp);
    if ( $test2 == 0 ) {
      rename( "$file_tmp", "$file" );
    }
  } ## end if ($test)
  else {
    $error++;
  }

  return $file;

} ## end sub create_configuration_info2

sub get_data_port {
  my $file    = shift;
  my $section = shift;
  my $metric  = shift;
  my @metrics = split( ",", $metric );

  my @data = get_array_data($file);
  my %header;
  my @array_port;

  foreach my $line (@data) {
    chomp $line;
    if ( $line eq "" ) { next; }
    if ( $line =~ /PORT/ ) {
      my $prev;
      foreach my $element (@metrics) {
        my $start_element = index( $line, $element );
        if ( $start_element == -1 ) { next; }
        else {
          if ( defined $prev ) {
            $header{$section}{$prev}{END} = $start_element - 1;
          }
          $header{$section}{$start_element}{NAME}  = $element;
          $header{$section}{$start_element}{START} = $start_element;
          if ( !defined $prev ) {
            $prev = $start_element;
            next;
          }
          if ( defined $header{$section}{$prev}{END} ) {
            $header{$section}{$prev}{LENGTH} = $header{$section}{$prev}{END} - $header{$section}{$prev}{START};
          }
          $prev = $start_element;

        } ## end else [ if ( $start_element ==...)]
      } ## end foreach my $element (@metrics)
    } ## end if ( $line =~ /PORT/ )
    if ( $line =~ /TAR/ ) {
      foreach my $id ( sort { $a <=> $b } keys %{ $header{$section} } ) {
        if ( defined $header{$section}{$id}{LENGTH} ) {
          my $name = $header{$section}{$id}{NAME};
          if ( $name ne "PORT" ) { next; }
          my $start  = $header{$section}{$id}{START};
          my $length = $header{$section}{$id}{LENGTH};
          if ( $start == 0 ) { $length--; }
          my $value = substr( $line, $start, $length );
          $value = remove_whitespace($value);
          push( @array_port, ",,$value,,,,,,\n" );
        } ## end if ( defined $header{$section...})
      } ## end foreach my $id ( sort { $a ...})

    } ## end if ( $line =~ /TAR/ )

  } ## end foreach my $line (@data)
  return @array_port;

  #print Dumper \%header;
  #print Dumper \@data;
  #print Dumper \@array_port;

} ## end sub get_data_port

sub cmd {
  my $cmd_raidcom = shift;
  my $file        = shift;
  my $timeout     = shift;
  my $save        = shift;
  my $pid         = fork();

  if ( !defined $pid ) {
    error_die( "no fork $!" . __FILE__ . ":" . __LINE__ );
  }
  elsif ( $pid == 0 ) {
    setpgrp( 0, 0 );
    if ( defined $save && $save eq "save" ) {
      `$cmd_raidcom >> "$file" 2>>\$ERRLOG_VSPG`;
    }
    else {
      `$cmd_raidcom > "$file" 2>>\$ERRLOG_VSPG`;
    }
    if ( $? != 0 ) {
      error( "command failed: $cmd_raidcom " . __FILE__ . ":" . __LINE__ );
    }
    exit(0);
  } ## end elsif ( $pid == 0 )
  eval {
    local $SIG{ALRM} = sub { die "die in SIGALRM"; };
    alarm($timeout);
    waitpid( $pid, 0 );
    alarm(0);
  };
  if ( $@ =~ /die in SIGALRM/ ) {
    my $act_time = localtime();
    error( "command: \"$cmd_raidcom > $file\" timed out after: $timeout seconds " . __FILE__ . ":" . __LINE__ );
    kill -15, $pid;
    waitpid( $pid, 0 );
  } ## end if ( $@ =~ /die in SIGALRM/)
  return;
} ## end sub cmd

sub get_array_data {
  my $file = shift;
  my $test = test_file_exist($file);
  if ($test) {
    open( FH, "< $file" ) || error_die( "Cannot read $file: $!" . __FILE__ . ":" . __LINE__ );
    my @file_all = <FH>;
    close(FH);
    return @file_all;
  } ## end if ($test)
  else {
    error( "File not exist $file: $!" . __FILE__ . ":" . __LINE__ );
    my @file_empty = "";
    return @file_empty;
  }
} ## end sub get_array_data

sub test_file_exist {
  my $file = shift;
  my $run  = shift;
  if ( !-e $file || -z $file ) {
    if ( defined $run && -z $file ) { return 1; }
    else {
      return 0;
    }
  } ## end if ( !-e $file || -z $file)
  else {
    return 1;
  }
} ## end sub test_file_exist

sub error_die {
  my $message = shift;
  print STDERR "$message\n";
  my $cmd  = "raidcom -logout $autetization";
  my $file = "/dev/null";
  cmd( $cmd, $file, $timeout_cmd_low );
  exit(1);
} ## end sub error_die

sub error {
  my $text     = shift;
  my $act_time = localtime();
  chomp($text);

  #print "ERROR          : $text : $!\n";
  print STDERR "$act_time: $text : $!\n";

  return 1;
} ## end sub error

